hdu 5726 GCD 解题报告

Give you a sequence of N(N100,000) integers : a1,...,an(0<ai1000,000,000) . There are Q(Q100,000) queries. For each query l,r you have to calculate gcd(al,,al+1,...,ar) and count the number of pairs (l,r)(1l<rN) such that gcd(al,al+1,...,ar) equal gcd(al,al+1,...,ar)
.
Input
The first line of input contains a number T , which stands for the number of test cases you need to solve.

The first line of each case contains a number N , denoting the number of integers.

The second line contains N integers, a1,...,an(0<ai1000,000,000) .

The third line contains a number Q , denoting the number of queries.

For the next Q lines, i-th line contains two number , stand for the li,ri
, stand for the i-th queries.
Output
For each case, you need to output “Case #:t” at the beginning.(with quotes, t means the number of the test case, begin from 1).

For each query, you need to output the two numbers in a line. The first number stands for gcd(al,al+1,...,ar) and the second number stands for the number of pairs (l,r) such that gcd(al,al+1,...,ar) equal gcd(al,al+1,...,ar)
.
Sample Input
1
5
1 2 4 6 7
4
1 5
2 4
3 4
4 4
Sample Output

Give you a sequence of N(N100,000) integers : a1,...,an(0<ai1000,000,000) . There are Q(Q100,000) queries. For each query l,r you have to calculate gcd(al,,al+1,...,ar) and count the number of pairs (l,r)(1l<rN) such that gcd(al,al+1,...,ar) equal gcd(al,al+1,...,ar)

.
Input
The first line of input contains a number T , which stands for the number of test cases you need to solve.

The first line of each case contains a number N , denoting the number of integers.

The second line contains N integers, a1,...,an(0<ai1000,000,000) .

The third line contains a number Q , denoting the number of queries.

For the next Q lines, i-th line contains two number , stand for the li,ri
, stand for the i-th queries.
Output
For each case, you need to output “Case #:t” at the beginning.(with quotes, t means the number of the test case, begin from 1).

For each query, you need to output the two numbers in a line. The first number stands for gcd(al,al+1,...,ar) and the second number stands for the number of pairs (l,r) such that gcd(al,al+1,...,ar) equal gcd(al,al+1,...,ar)
.
Sample Input
1
5
1 2 4 6 7
4
1 5
2 4
3 4
4 4
Sample Output
Case #1:
1 8
2 4
2 4
6 1
题意:

给你n个数字,现在问你q次L,R区间的gcd值以及有多少个区间的gcd值和L,R相等(L,R本身也算一个)

思路:

先用rmq预处理计算任意区间的gcd值;然后计算和该区间gcd相等的区间有多少个,代码如下:

#include <bits/stdc++.h>//建议从主函数开始看
using namespace std;
#define LL long long
const int maxn = 100005;
int dp[maxn][20];//dp[i][j]代表从第i位开始往后(1<<j)位的gcd值
int num[maxn],n;
int gcd(int a,int b){
    return a==0?b:gcd(b%a,a);
}
void init(){
    memset(dp,0,sizeof(dp));
    for(int i=1;i<=n;i++)dp[i][0]=num[i];//(1<<0还是1嘛)
    for(int j=1;(1<<j)<=n;j++){
        for(int i=1;i+(1<<j)-1<=n;i++){
            dp[i][j]=gcd(dp[i][j-1],dp[i+(1<<(j-1))][j-1]);
        }
    }
}
int rmq(int l,int r){
    int t=0;
    while(1<<(t+1)<=(r-l+1))t++;
    return gcd(dp[l][t],dp[r+1-(1<<t)][t]);//如果我们查询一段区间的gcd值的话,那么图一和图二的查询结果一定是一样的,这个可以自己证)
}
map<int,LL>m;//m[i]代表gcd值为i的区间有多少个

int main(){
    int test;
    scanf("%d",&test);
    int T=0;
    while(test--){
        T++;
        m.clear();
        scanf("%d",&n);
        for(int i=1;i<=n;i++)scanf("%d",&num[i]);
        init();
        for(int i=1;i<=n;i++){//这里统计各区间的gcd值
            int l=i,r=i;//当你计算l,r的区间gcd值时随着r的增加这个值一定是递减的,所以我们可以这样计算:
//首先枚举i端点,然后二分找到一个最右边的r使区间(l,r)的gcd等于(l,l),也就是说此时(l,r+1)是一个比之前小的gcd值,再如法炮制从(l,r+1)找有多少个和(l,r+1)
//gcd值相等的区间,由于不知道什么鬼的证明说对于一个端点i最多能找出来log2(n)个gcd值,而每次找的复杂度为log2(n),所以这里整体复杂度为n*logn*logn;
       while(r<=n){
                int ll=r;
                int rr=n;
                int v=rmq(l,r);
                while(ll<=rr){//二分找有多少个区间gcd等于(l,r)
                    int mid=(rr+ll)/2;
                    if(rmq(l,mid)>=v)ll=mid+1;
                    else rr=mid-1;
                }
                m[v]+=ll-r;
                r=ll;//更新r,这样可以继续找
            }
        }
        int q;
        scanf("%d",&q);
        printf("Case #%d:\n",T);
        while(q--){
            int L,R;
            scanf("%d%d",&L,&R);
            int ans=rmq(L,R);
            printf("%d %lld\n",ans,m[ans]);
        }
    }
}




  • 1
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 1
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论 1
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值